/* Utility to convert location coordinates to AERMAP input file. */

import java.util.*;
import java.io.*;
import java.text.*;

public class Convertmap
{
  static int east = 379882;
  static int north = 210464;
  static String demfile = "3418-4024.dem";
  static String aermapinpfile = "aermap.inp";

  public static void main(String[] args)
  {
    try {
      PrintStream o = new PrintStream(new FileOutputStream(aermapinpfile));
      o.println("CO STARTING");
      o.println("   TITLEONE Incineraptor model 1");
      o.println("   TERRHGTS  EXTRACT");
      o.println("   ANCHORXY  0 0 "+east+" "+north+" 1 0");
      o.println("   DATATYPE  DEM");
      o.println("   DATAFILE  "+demfile+" CHECK");
      o.println("   RUNORNOT  RUN");
      o.println("CO FINISHED");
      o.println("SO STARTING");
      o.println("   ELEVUNIT  METERS");
      o.println("   LOCATION  STACK  POINT  0.0   0.0   0.0");
      o.println("SO FINISHED");
      o.println("RE STARTING");
      double x, y;
      String line;
      String[] words;
      BufferedReader i = new BufferedReader(new FileReader(args[0]));
      while ((line = i.readLine()) != null) {
        words = line.split("\t");
        x = Double.parseDouble(words[1]) - east;
        y = Double.parseDouble(words[2]) - north;
        o.println("RE DISCCART  "+x+" "+y);
      }
      i.close();
      o.println("RE FINISHED");
      o.println("OU STARTING");
      o.println("   RECEPTOR  receptors.txt");
      o.println("   SOURCLOC  source.txt");
      o.println("OU FINISHED");
      o.close();
    } catch (Exception e) {
      System.out.println("Error: ");
      System.out.println(e.toString());
      System.exit(1);
    }
  }
}
