/* Utility to convert output plot file (from AERMOD) into meaningful form, with place names or absolute grid refs */

import java.util.*;
import java.io.*;
import java.lang.reflect.Array;

public class Convertout
{
  static String aerplotpath = "plot.txt";
  static int east = 379882;
  static int north = 210464;

  public static void main(String[] args)
  {
    double conc;
    String name;
    try {
      Map<String, String> locmap = locationnames(args[0], east, north);
      Map<String, Double> concmap = new HashMap<String, Double>();
      plotaer(concmap);
      PrintStream o = new PrintStream(new FileOutputStream("out-"+args[0]));
      for (String s : concmap.keySet()) {
        name = locmap.get((int)Double.parseDouble(s.substring(0, 14))+","+(int)Double.parseDouble(s.substring(14, 28)));
        conc = concmap.get(s);
        o.println(name+"\t"+conc);
      }
      o.close();
    } catch (Exception e) {
      System.out.println("Error: ");
      System.out.println(e.toString());
      System.exit(1);
    }
  }

  private static Map<String, String> locationnames(String locfile, int east, int north) throws Exception
  {
    String line, type, e, n, key, name;
    Map<String, String> names = new HashMap<String, String>();
    String[] words;
    BufferedReader i = new BufferedReader(new FileReader(locfile));
    while ((line = i.readLine()) != null) {
      words = line.split("\t");
      type = words[0];
      e = words[1].trim();
      n = words[2].trim();
      if (Array.getLength(words) >= 4) {
        name = words[3].replaceAll("%", " ");
      }
      else {
        name = e+","+n;
      }
      if (type.equals("r")) {
        key = e+","+(-Integer.parseInt(n));
      }
      else {  // type.equals("a")
        key = (Integer.parseInt(e)-east)+","+(Integer.parseInt(n)-north);
      }
      names.put(key, name);
    }
    i.close();
    return names;
  }

  private static void plotaer(Map<String, Double> concmap) throws Exception
  {
    double x, y, c;
    String line, key;
    String[] words;
    BufferedReader i = new BufferedReader(new FileReader(aerplotpath));
    while ((line = i.readLine()) != null) {
      if (!line.trim().equals("") && !line.startsWith("*")) {
        words = line.split(" ");
        x = Double.parseDouble(line.substring(0, 14));
        y = Double.parseDouble(line.substring(14, 28));
        c = Double.parseDouble(line.substring(28, 42));
        key = line.substring(0, 14)+line.substring(14, 28);
        concmap.put(key, c);
      }
    }
    i.close();
  }
}